<?php
add_action('userpro_after_profile_img','userpro_rating_profile' ,10 , 1 );
add_action('userpro_after_name_user_list', 'userpro_rating' , 10 , 1);
function userpro_rating($user_id){
	$content = '';
	$all_score = array();
	$all_score = get_option('upr_rating_'.$user_id);
	if(count($all_score)>0){
		if(is_array($all_score)){
			$score = array_sum($all_score)/count($all_score);
		}else{
			$score = 0;		
		}		
		$content =  '<div class="rate-now"><span id="rate-'.$user_id.'"></span> <span id="rate-points"> '.round($score,1).'</span></div>
			<script type="text/javascript">jQuery(\'#rate-'.$user_id.'\').raty({
				halfShow : true,
				half: true,
				readOnly: true,
				score: '.$score.',
				path: "'.UPR_PLUGIN_URL.'images/"
				});</script>';
	
	}
	echo $content;
}


function userpro_rating_profile($user_id){
	$content = '';
	$all_score = array();
	$all_score = get_option('upr_rating_'.$user_id);
	if(count($all_score)>0){
		if(is_array($all_score)){
			$score = array_sum($all_score)/count($all_score);
		}else{
			$score = 0;
		}

		$content =  '<div class="rate-now"><span id="rate-'.$user_id.'"></span> <span id="rate-points"> '.round($score,1).'</span></div>
			<script type="text/javascript">jQuery(\'#rate-'.$user_id.'\').raty({
				halfShow : true,
				half: true,';
		if(is_rating_allowed($user_id)){
			$content .= 'click: function(score,evt){
						ratebyuid("'.$user_id.'",score);
					},';
		}else {
			$content .= 'readOnly: true,';
		}
		$content .= 'score: '.$score.',
				path: "'.UPR_PLUGIN_URL.'images/"
				});</script>';

	}
	echo $content;
}

function is_rating_allowed($pid) {
	if ( ! isset( $wp_roles ) ) $wp_roles = new WP_Roles();
	$roles = $wp_roles->get_names();
	
	$uid = get_current_user_id();
	$urole = get_current_user_role();
	$prole =  get_role_by_id($pid);
	$Resticted_roles = userpro_rating_get_option('usepro_rating_roles_can_rate');
	$Allowed_roles = userpro_rating_get_option('usepro_rating_'.$urole.'_can_rate');
	if($Allowed_roles == null) {
		return true;
	}
	if ($Resticted_roles == null)
		$Resticted_roles = array();
	if(is_array($Allowed_roles) && in_array($prole, $Allowed_roles) && !in_array($urole, $Resticted_roles)){
		return true;
	}else{
		return false;
	}
	return false;
}

function get_current_user_role() {
	global $wp_roles;
	$current_user = wp_get_current_user();
	$roles = $current_user->roles;
	$role = array_shift($roles);
	return isset($wp_roles->role_names[$role]) ? $role : false;
}

function get_role_by_id($uid) {
	global $wp_roles;
	$user = get_user_by('id', $uid);
	$roles = $user->roles;
	$role = array_shift($roles);
	return isset($wp_roles->role_names[$role]) ? $role : false;
}


add_action('userpro_after_profile_img','display_review_textarea' , 11 , 1);

function display_review_textarea($user_id){
	global $post;
	if(is_rating_allowed($user_id)) {
	if(isset($post->post_name) && $post->post_name == userpro_get_option('slug') && is_user_logged_in() && $user_id != get_current_user_id()) {
		$user_reviews = get_user_meta($user_id , 'user_reviews');
		if( !isset($user_reviews[0]) )
			$user_reviews[0] = array();
		if(array_key_exists(get_current_user_id() , $user_reviews[0])) {
			echo '<div>You have already submitted a review for this user.</div>';
			$page_id = get_option('userpro_review_page_link');
			$link = get_review_page_link($user_id);
		if($page_id)
			echo '<a href="'.$link.'">View Reviews</a>';
		}else{
			$maxlength = (userpro_rating_get_option('userpro_rating_review_length')) ? userpro_rating_get_option('userpro_rating_review_length') : '255';
			echo '<textarea name="user_review" id="user_review" maxlength="'.$maxlength.'" placeholder="Write a review" data-reciever_userid="'.$user_id.'" data-sender_userid="'.get_current_user_id().'"></textarea>
					<div style="display:none;" id="review_msg">Thank you for submitting the review</div>';
		}
	}else{
		$page_id = get_option('userpro_review_page_link');
			$link = get_review_page_link($user_id);
		if($page_id)
			echo '<a href="'.$link.'">View Reviews</a>';
	}
	}
}

add_action( 'save_post', 'userpro_is_review_shortcode' );

function userpro_is_review_shortcode($post_id){
	$post = get_post($post_id);
	$pattern = get_shortcode_regex();
	preg_match('/'.$pattern.'/s', $post->post_content, $matches);
	if (is_array($matches) && isset($matches[2]) && $matches[2] == 'userpro') {
		if(preg_match('/reviews/s', $matches[3])){
			update_option('userpro_review_page_link', $post_id);
		}
	}
}

function get_review_page_link($user_id) {
	$page_id = get_option('userpro_review_page_link');
	$user = get_userdata( $user_id );
	$nice_url = userpro_get_option('permalink_type');
	if ($nice_url == 'ID') {
		$clean_user_login = $user_id;
	}
	if ($nice_url == 'username') {
		$clean_user_login = $user->user_login;
		$clean_user_login = str_replace(' ','-',$clean_user_login);
	}
	if ($nice_url == 'name'){
		$clean_user_login = $this->get_fullname_by_userid( $user_id );
	}
	if ($nice_url == 'display_name'){
		$clean_user_login = userpro_profile_data('display_name', $user_id);
		$clean_user_login = str_replace(' ','-',$clean_user_login);
		$clean_user_login = urlencode($clean_user_login);
	}
	if ( get_option('permalink_structure') == '' ) {
		$link = add_query_arg( 'up_username', $clean_user_login, get_page_link($page_id) );
	} else {
		$link = trailingslashit ( trailingslashit( get_page_link($page_id) ) . $clean_user_login );
	}
	return $link;
}
